代码随想录算法训练营第二天| LeetCode 977.有序数组的平方 ,209.长度最小的子数组 ,59.螺旋矩阵II
977.有序数组的平方
题目链接:https://leetcode.cn/problems/squares-of-a-sorted-array/
文章讲解:https://programmercarl.com/0977.%E6%9C%89%E5%BA%8F%E6%95%B0%E7%BB%84%E7%9A%84%E5%B9%B3%E6%96%B9.html
视频讲解: https://www.bilibili.com/video/BV1QB4y1D7ep
卡哥的题目建议:建议大家先独立做题,然后看视频讲解,然后看文章讲解,然后在重新做一遍题,把题目AC,最后整理成今日当天的博客,拓展题目可以先不做。本题关键在于理解双指针思想。
做题思路:
有两种方法,暴力解法和双指针法。非递减顺序就是递增顺序,从小到大排。
暴力解法思路:就是将数组中的每个数平方后,再按从小到大的顺序排序。C++的sort函数是基于快速排序实现的,函数原型 void sort(first,last),first是要排序的数组的起始地址,last是结束的地址(最后一个数据的后一个数据的地址)。如果利用迭代器,就可以用sort(a.begin(),a.end()),
1 #include <iostream>
2 #include <algorithm>
3 using namespace std;
4 const int N = 10;
5 int a[N]; //声明全局数组
6 int main()
7 {
8 int n; //数组的元素个数为 n
9 cout << "请输入数组的元素个数:" << endl;
10 cin >> n;
11 cout << "请输入数组:" << endl;
12 for (int i = 0; i < n; i++)
13 {
14 cin >> a[i]; //循环输入数组中的元素
15 }
16 for (int i = 0; i < n; i++)
17 {
18 a[i] *= a[i];
19 }
20 sort(a,a+n); //注意:这里没有利用迭代器
21 for (int i = 0; i < n; i++)
22 {
23 cout << a[i] << " "; //循环输入数组中的元素
24 }
25
26 return 0;
27 }
运行结果:

双指针法思路:
先看给的数组,nums = [-4,-1,0,3,10],有负数;再平方后,nums = [16,1,0,9,100],观察到平方后的数组两边的数比中间的大,所以我们可以考虑从第一个位置向后开始,最后一个位置向前开始,比较谁大,如果最后一个位置的数大的话,那就把这个数存放到新数组中,随着第一个位置和最后一个位置的移动,就能实现排序,有移动的动图,在文章链接里。这个两个位置就可以用双指针解决,其实就是两个变量。
1 #include <iostream>
2 using namespace std;
3 const int N = 10;
4 int a[N]; //声明全局数组
5 int main()
6 {
7 int n; //数组的元素个数为 n
8 cout << "请输入数组的元素个数:" << endl;
9 cin >> n;
10 cout << "请输入数组:" << endl;
11 for (int i = 0; i < n; i++)
12 {
13 cin >> a[i]; //循环输入数组中的元素
14 }
15 for (int i = 0; i < n; i++)
16 {
17 a[i] *= a[i];
18 }
19 int result[N];//放排好序的新数组
20 int k = n - 1; //新数组的下标为k,因为我们是先把大的数放进新数组,所以k值从n - 1开始
21 int first = 0;
22 int last = n - 1;
23 while (first <= last) //第一个位置的下标肯定比最后一个位置下标小或等于,才合法
24 {
25 if (a[first] < a[last])
26 {
27 result[k] = a[last];//最后一个位置比第一个位置大,就把最后一个位置的数放到新数组
28 k--; //比较完后,新数组的实际大小减一,更新下标
29 last--;//最后一个位置的数放到新数组,最后一个位置向前移动
30 }
31 else
32 {
33 result[k] = a[first];//第一个位置比最后一个位置大,
34 k--;//比较完后,新数组的实际大小减一,更新下标
35 first++;//第一个位置的数放到新数组,第一个位置向后移动
36 }
37 }
38 for (int i = 0; i < n; i++)
39 {
40 cout << result[i] << " "; //循环输入数组中的元素
41 }
42
43 return 0;
44 }
运行结果:

209.长度最小的子数组
卡哥的题目建议:本题关键在于理解滑动窗口,这个滑动窗口看文字讲解 还挺难理解的,建议大家先看视频讲解。 拓展题目可以先不做。
做题思路:
有两种方法,暴力解法和双指针法。
暴力解法思路:这个题是为了找到和大于某个值的长度最小的连续子数组,所以先找到和大于某个值的子数组集合,再找长度最小的。可以用两层for循环,外层循环先定好从哪个地方开始找子数组,内层循环求和,从下标为0的地方开始找和大于某个值的位置,如果和大于某个值,就先记录下这个位置到外层循环定好的位置之间的长度,后面的位置没有必要寻找了。然后开始下一轮外层循环,同理.......再记录,更新长度;直到外层循环完后,才能把最短长度求出来。所以暴力解法会超时。
1 #include <iostream>
2 using namespace std;
3 const int N = 10;
4 int a[N]; //声明全局数组
5 int minSubArrayLen(int a[], int s)
6 {
7 int n = sizeof(a);
8 int result = INT32_MAX; // 最终的结果,INT32_MAX是int的最大值,2的16次方 - 1
9 int sum = 0; // 子数组的数值之和
10 int subLength = 0; // 子数组的长度
11 for (int i = 0; i < n; i++) //外层循环
12 {
13 sum = 0; //每一轮外层循环的时候,重置sum值,为了记录不同i值下的长度
14 for (int j = i; j < n; j++) //内层循环
15 {
16 sum += a[j];
17 if (sum >= s)//求和,从下标为0的地方开始找和大于某个值的位置
18 {
19 subLength = j - i + 1; //记录下这个位置到外层循环定好的位置之间的长度
20 result = result < subLength ? result : subLength;//如果小于最终长度,那最终长度不变;如果大于最终长度,那更新最终长度
21 break;
22 }
23 }
24 }
25 return result == INT32_MAX ? 0 : result;//如果result没有被赋值的话,就返回0,说明没有符合条件的子数组
26 }
27 int main()
28 {
29 int n; //数组的元素个数为 n
30 cout << "请输入数组的元素个数:" << endl;
31 cin >> n;
32 cout << "请输入数组:" << endl;
33 for (int i = 0; i < n; i++)
34 {
35 cin >> a[i]; //循环输入数组中的元素
36 }
37 int s;
38 cout << "请输入正整数 s :" << endl;
39 cin >> s;
40 cout << minSubArrayLen(a, s) << endl;
41 return 0;
42 }
运行结果:

双指针法思路:我们为了找到和大于某个值的长度最小的连续子数组,想像在数组上移动着找,刚开始会像暴力解法那样,定好一个起始位置,再移动另一个位置,但是如果两个位置都移动,效率就会提升很多,所以就引出了滑动窗口这个方法。在滑动窗口中,分起始位置和终止位置,终止位置用来找到和大于某个值的连续子数组集合;起始位置用来找最短长度,和暴力解法不同的是,当找到了和大于某个值的连续子数组集合后,就是终止位置暂时不移动了,同时记录下长度,起始位置此时从下标0开始移动,每移动一个位置,就用刚求好的和减去上一个位置的数,为了看还能不能找到更短的长度;如果不能的话,那只能移动终止位置,去重新找和大于某个值的连续子数组集合。同理,直到终止位置移动到数组尾部,且找不到最短长度了,就停止。
1 #include <iostream>
2 using namespace std;
3 const int N = 10;
4 int a[N]; //声明全局数组
5 int minSubArrayLen(int a[], int s)
6 {
7 int n = sizeof(a);
8 int result = INT32_MAX; // 最终的结果,INT32_MAX是int的最大值,2的16次方 - 1
9 int sum = 0; //滑动窗口的数值之和
10 int subLength = 0; //滑动窗口的长度
11 int i = 0; //滑动窗口起始位置
12 for (int j = 0; j < n; j++)
13 {
14 sum += a[j];
15 // 注意这里使用while,每次更新 i(起始位置),并不断比较子数组是否符合条件
16 while (sum >= s) {
17 subLength = (j - i + 1); // 取子数组的长度
18 result = result < subLength ? result : subLength;
19 sum -= a[i]; // 这里体现出滑动窗口的精髓之处,不断变更i(子数组的起始位置)
20 i++; //起始位置向后移动
21 }
22 }
23 return result == INT32_MAX ? 0 : result;//如果result没有被赋值的话,就返回0,说明没有符合条件的子数组
24 }
25 int main()
26 {
27 int n; //数组的元素个数为 n
28 cout << "请输入数组的元素个数:" << endl;
29 cin >> n;
30 cout << "请输入数组:" << endl;
31 for (int i = 0; i < n; i++)
32 {
33 cin >> a[i]; //循环输入数组中的元素
34 }
35 int s;
36 cout << "请输入正整数 s :" << endl;
37 cin >> s;
38 cout << minSubArrayLen(a, s) << endl;
39 return 0;
40 }
运行结果:

59.螺旋矩阵II
卡哥的题目建议:本题关键还是在转圈的逻辑,在二分搜索中提到的区间定义,在这里又用上了。
做题思路:
我感觉这里看视频和文章就能理解,就是要想到矩阵可以是一个正方形,从总共能走的圈数,再从正方形4条边入手,这些边可以当做在一个区间上,写一些区间上的边界的限制条件。结合之前做的题,会想到左闭右闭,左闭右开........
1 #include <iostream>
2 using namespace std;
3 const int N = 10;
4 int main()
5 {
6 int n;
7 cout << "请输入一个正整数 n:" << endl;
8 cin >> n;
9 int res[N][N] = { 0 };
10 int startx = 0, starty = 0; // 定义每循环一个圈的起始位置,相当于一个坐标(startx, starty)
11 int loop = n / 2; // 这个可以画图理解,每个圈循环几次,例如n为奇数3,那么loop = 1 只是循环一圈,矩阵中间的值需要单独处理
12 int mid = n / 2; // 矩阵中间的位置,例如:n为3, 中间的位置就是(1,1),n为5,中间位置为(2, 2)
13 int count = 1; // 用来给矩阵中每一个空格赋值
14 int offset = 1; // 每一圈右边界向里收缩一位
15 int i, j;
16 while (loop--)
17 {
18 i = startx;
19 j = starty;
20
21 // 下面开始的四个for就是模拟转了一圈
22 // 模拟填充上行从左到右(左闭右开)
23 for (j = starty; j < n - offset; j++) //行不变,列变,所以列的初始值一开始为0,右开,右边界值不能取到
24 {
25 res[startx][j] = count++;
26 }
27 // 模拟填充右列从上到下(左闭右开)
28 for (i = startx; i < n - offset; i++) //列不变,行变,所以行的初始值一开始为0,右开,右边界值不能取到
29 {
30 res[i][j] = count++;
31 }
32 // 模拟填充下行从右到左(左闭右开)
33 for (; j > starty; j--) //走到了i, j 的最大值处,不需要设行列的初始值,行不变,列变,列不能比0小
34 {
35 res[i][j] = count++;
36 }
37 // 模拟填充左列从下到上(左闭右开)
38 for (; i > startx; i--)//走到了 i 的最大值处........
39 {
40 res[i][j] = count++;
41 }
42
43 // 第二圈开始的时候,起始位置要各自加1, 例如:第一圈起始位置是(0, 0),第二圈起始位置是(1, 1)
44 startx++;
45 starty++;
46
47 // offset 控制每一圈里每一条边遍历的长度
48 offset += 1;
49 }
50
51 // 如果n为奇数的话,需要单独给矩阵最中间的位置赋值
52 if (n % 2 == 1)
53 {
54 res[mid][mid] = count;
55 }
56 for (int i = 0; i < n; i++) //矩阵为 n*n
57 {
58 cout << "[";
59 for (int j = 0; j < n; j++)
60 {
61 cout << res[i][j] << " ";
62 }
63 cout << "]";
64 cout << endl;
65 }
66 return 0;
67 }
运行结果:

最后,数组的总结看一下卡哥的吧。
代码随想录算法训练营第二天| LeetCode 977.有序数组的平方 ,209.长度最小的子数组 ,59.螺旋矩阵II的更多相关文章
- 代码随想录算法训练营第二天| 977.有序数组的平方 ,209.长度最小的子数组 ,59.螺旋矩阵II
977.有序数组的平方 :https://leetcode.cn/problems/squares-of-a-sorted-array/ 心得:周末再写... public class Solutio ...
- 代码随想录训练营day 2 |977有序数组的平方 209.长度最小的子数组 (C++)
977.有序数组的平方 题目链接:977.有序数组的平方 题目描述:给你一个按 非递减顺序 排序的整数数组 nums,返回 每个数字的平方 组成的新数组,要求也按 非递减顺序 排序. 例子如下: 输入 ...
- 代码随想录第二天| 977.有序数组的平方 ,209.长度最小的子数组 ,59.螺旋矩阵II
2022/09/22 第二天 第一题 这题我就直接平方后排序了,很无脑但很快乐啊(官方题解是双指针 第二题 滑动窗口的问题,本来我也是直接暴力求解发现在leetCode上超时,看了官方题解,也是第一次 ...
- Leetcode 209.长度最小的子数组 By Python
给定一个含有 n 个正整数的数组和一个正整数 s ,找出该数组中满足其和 ≥ s 的长度最小的连续子数组.如果不存在符合条件的连续子数组,返回 0. 示例: 输入: s = 7, nums = [2, ...
- LeetCode 209. 长度最小的子数组(Minimum Size Subarray Sum)
题目描述 给定一个含有 n 个正整数的数组和一个正整数 s ,找出该数组中满足其和 ≥ s 的长度最小的连续子数组.如果不存在符合条件的连续子数组,返回 0. 示例: 输入: s = 7, nums ...
- Java实现 LeetCode 209 长度最小的子数组
209. 长度最小的子数组 给定一个含有 n 个正整数的数组和一个正整数 s ,找出该数组中满足其和 ≥ s 的长度最小的连续子数组.如果不存在符合条件的连续子数组,返回 0. 示例: 输入: s = ...
- 【LeetCode】209. 长度最小的子数组
209. 长度最小的子数组 知识点:数组:前缀和:二分法:双指针:滑动窗口 题目描述 给定一个含有 n 个正整数的数组和一个正整数 target . 找出该数组中满足其和 ≥ target 的长度最小 ...
- 代码随想录训练营day 3|59.螺旋矩阵II 加 数组总结篇
59.螺旋矩阵II 题目链接:59.螺旋矩阵II 题目描述:给定一个正整数 n,生成一个包含 1 到 n^2 所有元素,且元素按顺时针顺序螺旋排列的正方形矩阵. 示例: 输入: 3 输出: [ [ 1 ...
- LeetCode:长度最小的子数组【209】
LeetCode:长度最小的子数组[209] 题目描述 给定一个含有 n 个正整数的数组和一个正整数 s ,找出该数组中满足其和 ≥ s 的长度最小的连续子数组.如果不存在符合条件的连续子数组,返回 ...
- leetcode 54. 螺旋矩阵 及 59. 螺旋矩阵 II
54. 螺旋矩阵 问题描述 给定一个包含 m x n 个元素的矩阵(m 行, n 列),请按照顺时针螺旋顺序,返回矩阵中的所有元素. 示例 1: 输入: [ [ 1, 2, 3 ], [ 4, 5, ...
随机推荐
- [OpenCV-Python] 24 模板匹配
文章目录 OpenCV-Python:IV OpenCV中的图像处理 24 模板匹配 24.1 OpenCV 中的模板匹配 24.2 多对象的模板匹配 OpenCV-Python:IV OpenCV中 ...
- Pytorch数据操作
1.Pytorch中tensor的生成与访问 可以使用arange()创建一个张量:如,torch.arange(12)创建0开始的前12个整数: 除非特殊指定,否则新的张量将存放在内存中,并采用CP ...
- 2022-03-25:给定一个长度为 N 的字符串 S,由字符‘a‘和‘b‘组成,空隙由 ‘?‘ 表示。 你的任务是用a字符或b字符替换每个间隙, 替换完成后想让连续出现同一种字符的最长子串尽可能短。
2022-03-25:给定一个长度为 N 的字符串 S,由字符'a'和'b'组成,空隙由 '?' 表示. 你的任务是用a字符或b字符替换每个间隙, 替换完成后想让连续出现同一种字符的最长子串尽可能短. ...
- 2022-03-01:k8s安装phpmyadmin,yaml如何写?
2022-03-01:k8s安装phpmyadmin,yaml如何写? 答案2022-03-01: yaml如下: apiVersion: apps/v1 kind: Deployment metad ...
- 2021-07-06:股票问题3。给定一个数组,它的第 i 个元素是一支给定的股票在第 i 天的价格。设计一个算法来计算你所能获取的最大利润。你最多可以完成 两笔 交易。注意:你不能同时参与多笔交易(
2021-07-06:股票问题3.给定一个数组,它的第 i 个元素是一支给定的股票在第 i 天的价格.设计一个算法来计算你所能获取的最大利润.你最多可以完成 两笔 交易.注意:你不能同时参与多笔交易( ...
- el-table自适应列宽
这里可对内容为文本的列进行自适应列宽 以下为 工具方法 /** * 使用span标签包裹内容,然后计算span的宽度 width: px * @param valArr */ function get ...
- ubuntu搜狗输入法显示简体中文,输入却是繁体中文问题解决方案
一.现场重现 我的ubuntu版本是20.04,搜狗输入法版本是2.4.在输入的时候发生了如下场景: 明明输入法上是简体中文,可是打出来就变成了繁体中文! 二.解决方案 1.尝试 网上许多答案都是按下 ...
- HCIP- ICT实战进阶ex1-MPLS
HCIP- ICT实战进阶ex1-MPLS 0 前言 由于BGP设备之间是通过TCP协议实现的跨设备互联, 所以在两台BGP设备之间的其他设备是没有配置BGP协议的, 因此中间的其他设备很可能无法学习 ...
- 对promise的简单理解
随着ES6的推行它的许多新特性受到了广大开发者的好评,比如promise,为什么使用这个promise呢,他具体能帮我们做些啥? 其实从字面意思上来理解promise就是承诺,比如:你命令你的手下本月 ...
- SPI通信协议
1. SPI 通信协议简介 SPI 协议是由摩托罗拉公司提出的通讯协议(Serial Peripheral Interface),即串行外围设 备接口,是一种高速全双工的通信总线.它被广泛地使用在 A ...